#ifndef _COMMON_C
#define _COMMON_C


///// Includes /////
#include <pspctrl.h>
#include <pspdisplay.h>
#include <pspkernel.h>
#include <pspdebug.h>
#include "conf.h"
#include "graphics.h"
#include "fontloader.h"


///// Defines /////
#define STATE_MENU		1
#define	STATE_GAME		2
#define	STATE_OPTIONS	3
#define STATE_EXIT		4

#define HOME			PSP_CTRL_HOME
#define UP				PSP_CTRL_UP
#define RIGHT			PSP_CTRL_RIGHT
#define	DOWN			PSP_CTRL_DOWN
#define	LEFT			PSP_CTRL_LEFT
#define START			PSP_CTRL_START
#define SELECT			PSP_CTRL_SELECT
#define TRIANGLE		PSP_CTRL_TRIANGLE
#define CIRCLE			PSP_CTRL_CIRCLE
#define CROSS			PSP_CTRL_CROSS
#define	SQUARE			PSP_CTRL_SQUARE
#define	LTRIGGER		PSP_CTRL_LTRIGGER
#define	RTRIGGER		PSP_CTRL_RTRIGGER

#define	CLICK_PATH		"resources/click.mp3"
#define	NEXT_PATH		"resources/next.mp3"
#define	CONFIG_PATH		"resources/data.sav"
#define FONT_PATH		"resources/font.ttf"

#define MAX_HP			100

#define RGB(r, g, b)	(0xFF000000 | ((b)<<16) | ((g)<<8) | (r))


///// GLOBALS /////
/* Images */
Image* player;
Image* cursor;
Image* stage1; Image* stage2; Image* stage3; Image* stage4;
Image* youDied; Image* deadTop; Image* deadBot;
Image* enemy1; Image* enemy2; Image* enemy3; Image* enemy4;
Image* arrow;
Image* door; Image* door2; Image* door3;
Image* armLeft; Image* armRight;
Image* menuBG;

/* Font */
Font* myFont;



/* Other */
typedef struct
{
	// display level
	int level;
	char holdLevel[255];

} HUDinfo;

HUDinfo HUD;

typedef struct
{
	// display level
	char levelName[100];

} levelInfo;

levelInfo levelScreenData[20];

typedef struct
{
	// display level
	int x, y;

} bossInfo;

bossInfo hotSpots[20];

typedef struct
{
	// active or not
	int active;
	
	// x & y value
	int x, y;

	// Most enemies require a 'switch' (moving back and forth for example)
	int switcher;

	// The type of enemy
	int type;

} enemyInfo;

enemyInfo enemy[100];


SceCtrlData pad, oldpad;
CONFIGFILE config;
int state;
int curMenu, curMenuLevel, curMenuLevelPick;
int stage;
int stageX, stageY;
int playerX, playerY;
int mouseX, mouseY, mouseMoveX, mouseMoveY;
int cameraX, cameraY;
int gotoX, gotoY;
int dead, deadX, deadY, deadXtop, deadYtop, deadXbot, deadYbot;
int i;
int tutState;
int enemyTimer;
int enemyCur;
int doorSwitch; int crush;
int level3Timer;
int armXLeft, armYLeft, armXLeftGoto, armYLeftGoto;
int armXRight, armYRight, armXRightGoto, armYRightGoto;
int armTimer;
int countDown, countDownTimer; char countText[100];
int backCountTimer;
int bossGotoX, bossGotoY, bossSwitch;
int menuOption;

char cpuSpeed[100];
char difficulty[100];
char sensitivity[100];
int sens;






#endif
