/**
 *	BOUND
 * ------------------------
 *   LEVELDATA.C   |
 *   ------------
 *    Functions related to level handling
**/


/////////////////////////////////////////////////////////////////
///////////////////////// INCLUDES //////////////////////////////
/////////////////////////////////////////////////////////////////

#include <time.h>
#include "fontloader.h"
#include "display.h"
#include "mp3player.h"
#include "common.c"


/////////////////////////////////////////////////////////////////
///////////////////////// FUNCTIONS /////////////////////////////
/////////////////////////////////////////////////////////////////

/* input level # and appropriate level is loaded */
void loadLevel(int curLevel)
{
	// Set defaults
	for (i=1; i<=50; i++) {
		enemy[i].active = 0;
		enemy[i].x = 0;
		enemy[i].y = 0;
		enemy[i].switcher = 0;
		enemy[i].type = 1;
	}

	// Tut level
	if (curLevel == 0) {
		tutState = 0;
		mouseX = 480/2-115; mouseY = 272/2+10;
		stageX = 480/2; stageY = 272/2;
		cameraX = stageX-480/2; cameraY = stageY-272/2;
		playerX = 6; playerY = 5;

		// Set enemies
		enemy[1].active = 1; enemy[1].x = stageX+230; enemy[1].y = stageY+0; enemy[1].switcher = 1; enemy[1].type = 1;
		enemy[2].active = 1; enemy[2].x = stageX+290; enemy[2].y = stageY+50; enemy[2].switcher = 0; enemy[2].type = 1;
		enemy[3].active = 1; enemy[3].x = stageX+350; enemy[3].y = stageY+0; enemy[3].switcher = 1; enemy[3].type = 1;
		enemy[4].active = 1; enemy[4].x = stageX+410; enemy[4].y = stageY+50; enemy[4].switcher = 0; enemy[4].type = 1;
	}
	// Level 1
	else if (curLevel == 1) {
		mouseX = 480/2; mouseY = 272/2;
		stageX = 480/2; stageY = 272/2;
		cameraX = stageX-480/2; cameraY = stageY-272/2;
		playerX = 6; playerY = 5;
		
		// Set enemies
		enemy[1].active = 1; enemy[1].x = stageX+230; enemy[1].y = stageY+0; enemy[1].switcher = 1; enemy[1].type = 1;
		enemy[2].active = 1; enemy[2].x = stageX+290; enemy[2].y = stageY+50; enemy[2].switcher = 0; enemy[2].type = 1;
		enemy[3].active = 1; enemy[3].x = stageX+350; enemy[3].y = stageY+0; enemy[3].switcher = 1; enemy[3].type = 1;
		enemy[4].active = 1; enemy[4].x = stageX+410; enemy[4].y = stageY+50; enemy[4].switcher = 0; enemy[4].type = 1;
	}
	// Level 2
	else if (curLevel == 2) {
		mouseX = 480/2; mouseY = 272/2;
		stageX = 480/2; stageY = 272/2;
		cameraX = stageX-440; cameraY = stageY-272/2;
		playerX = 94; playerY = 5;
		enemyTimer = 140;
		enemyCur = 5;

		// Set enemies
		enemy[1].active = 1; enemy[1].x = stageX+21; enemy[1].y = stageY+39; enemy[1].switcher = 1; enemy[1].type = 1;
		//enemy[2].active = 1; enemy[2].x = stageX+21; enemy[2].y = stageY+111; enemy[2].switcher = 2; enemy[2].type = 1;
		//enemy[3].active = 1; enemy[3].x = stageX+209; enemy[3].y = stageY+111; enemy[3].switcher = 3; enemy[3].type = 1;
		enemy[4].active = 1; enemy[4].x = stageX+209; enemy[4].y = stageY+39; enemy[4].switcher = 4; enemy[4].type = 1;

		for (i=5; i<=14; i++) {
			enemy[i].active = 0; enemy[i].x = stageX+44+(30*(i-5)); enemy[i].y = stageY+226; enemy[i].switcher = 0; enemy[i].type = 2;
		}
	}
	// Level 3
	else if (curLevel == 3) {
		mouseX = 480/2; mouseY = 272/2;
		stageX = 480/2; stageY = 272/2;
		cameraX = stageX-270; cameraY = stageY-272-(272/2);
		playerX = 10; playerY = 252;
		doorSwitch = 1;
		crush = 0;
		enemyTimer = 25;
		enemyCur = 1-2;
		level3Timer = 30;
		// Set enemies
		for (i=1; i<=7; i++) {
			enemy[i].active = 0; enemy[i].x = stageX+50; enemy[i].y = stageY+196-(31*(i-1)); enemy[i].switcher = 0; enemy[i].type = 3;
		}
		enemy[8].active = 0; enemy[8].x = stageX+247; enemy[8].y = stageY+143; enemy[8].switcher = 0; enemy[8].type = 1;
		enemy[9].active = 0; enemy[9].x = stageX+272; enemy[9].y = stageY+143; enemy[9].switcher = 0; enemy[9].type = 1;
	}
	// Level 4
	else if (curLevel == 4) {
		mouseX = 480/2; mouseY = 272/2;
		stageX = 480/2; stageY = 272/2;
		cameraX = stageX-480; cameraY = stageY-272-(272/2);
		playerX = 224; playerY = 251;
		doorSwitch = 0;
		countDown = 180; countDownTimer = 60;
		bossSwitch = 0;
		enemyTimer = 60;
		armTimer = 30;
		backCountTimer = 60;

		// Seed the random function
		srand(sceKernelLibcTime(NULL));

		// Set hotspots to default
		for (i=1; i<=15; i++) {
			hotSpots[i].x = 0;
			hotSpots[i].y = 0;
		}
		// Define hotspots
		hotSpots[0].x = stageX+220; hotSpots[0].y = stageY+2; // (this is just incase)
		hotSpots[1].x = stageX+220; hotSpots[1].y = stageY+2;
		hotSpots[2].x = stageX+215; hotSpots[2].y = stageY+170;
		hotSpots[3].x = stageX+333; hotSpots[3].y = stageY+157;
		hotSpots[4].x = stageX+369; hotSpots[4].y = stageY+60;
		hotSpots[5].x = stageX+297; hotSpots[5].y = stageY+14;
		hotSpots[6].x = stageX+121; hotSpots[6].y = stageY+22;
		hotSpots[7].x = stageX+80; hotSpots[7].y = stageY+46;
		hotSpots[8].x = stageX+55; hotSpots[8].y = stageY+101;
		

		// The boss
		enemy[1].active = 0; enemy[1].x = stageX+220; enemy[1].y = stageY+10; enemy[1].switcher = 0; enemy[1].type = 4;
		armXLeft = 0; armYLeft = 0;
		armXRight = 0; armYRight = 0;
		bossGotoX = hotSpots[2].x; bossGotoY = hotSpots[2].y;
	}

	// Set some vars
	dead = 0; deadX = 0; deadY = -272; deadXtop = 0; deadYtop = -272/2; deadXbot = 0; deadYbot = 272;
	gotoX = playerX; gotoY = playerY;
	if (config.level < curMenuLevelPick) {
		char levelChar[100];
		sprintf(levelChar, "level = %d;", curMenuLevelPick);
		write_config(CONFIG_PATH, levelChar);
	}
	read_config(CONFIG_PATH, &config);
	stage = curMenuLevelPick;
	curMenuLevelPick++;
}

/* The transition from one level to another */
void transitionLevel()
{
	for (;;) {
		blitAlphaImageToScreen(0, 0, 10, 10, cursor, mouseX, mouseY);
		blitAlphaImageToScreen(0, 0, 480, 272/2, deadTop, deadXtop, deadYtop);
		blitAlphaImageToScreen(0, 0, 480, 272/2, deadBot, deadXbot, deadYbot);

		if (deadYtop < 0) {
			deadYtop += 3;
		}
		if (deadYbot > 272/2) {
			deadYbot -= 3;
		}
		else {
			// load level
			loadLevel(curMenuLevelPick);
			break;
		}

		flip();
	}
}

/* The select level screen */
int selectLevelScreen()
{
	// Set default
	for (i=0; i<=20; i++) {
		sprintf(levelScreenData[i].levelName, " ");
	}

	// Set new
	// The first one should be different since it's just a tut :P
	sprintf(levelScreenData[0].levelName, "Tutorial");
	for (i=1; i<=config.level; i++) {
		sprintf(levelScreenData[i].levelName, "Level %d", i);
	}
	sprintf(levelScreenData[config.level+1].levelName, "Back");
	

	for (;;) {

		// Update
		//fillScreenRect(RGB(0, 0, 0), 0, 0, 480, 272);
		blitAlphaImageToScreen(0, 0, 480, 272, menuBG, 0, 0);
		Font_Print_Screen(myFont, 5, 15, "V1a", RGB(255, 255, 255));

		// Get control
		oldpad = pad;
		sceCtrlReadBufferPositive(&pad, 1);

		// Control what gets displayed, and what doesn't
		for (i=0; i<=config.level+1; i++) {
			if (!((i==curMenuLevel) || (i==0) || (i==config.level+1))) // White text
				centerText(480/2, (20*(i-1)+40), levelScreenData[i].levelName, strlen(levelScreenData[i].levelName), RGB(255, 255, 255));
			else if ((i==curMenuLevel) && (!(i==0)) && (!(i==config.level+1))) // Blue text
				centerText(480/2, (20*(i-1)+40), levelScreenData[i].levelName, strlen(levelScreenData[i].levelName), RGB(0, 0, 200));

			if ((i==0) && (!(i==curMenuLevel))) // White text (tutorial)
				centerText(480/2+5, (20*(i-1)+40), levelScreenData[i].levelName, strlen(levelScreenData[i].levelName), RGB(255, 255, 255));
			else if ((i==0) && (i==curMenuLevel)) // Blue text (tutorial)
				centerText(480/2+5, (20*(i-1)+40), levelScreenData[i].levelName, strlen(levelScreenData[i].levelName), RGB(0, 0, 200));

			if ((i==config.level+1) && (!(i==curMenuLevel))) // White text (Back)
				centerText(480/2-5, (20*(i-1)+40)+15, levelScreenData[i].levelName, strlen(levelScreenData[i].levelName), RGB(255, 255, 255));
			else if ((i==config.level+1) && (i==curMenuLevel)) // Blue text (Back)
				centerText(480/2-5, (20*(i-1)+40)+15, levelScreenData[i].levelName, strlen(levelScreenData[i].levelName), RGB(0, 0, 200));
		}

		// Input
		if (pad.Buttons != oldpad.Buttons) {
			// Up routine
			if ((pad.Buttons & UP) && (!(oldpad.Buttons & UP))) {
				if (curMenuLevel > 0) curMenuLevel--;
				else curMenuLevel = config.level+1;
				playSound(CLICK_PATH);
			}
			// Down routine
			else if ((pad.Buttons & DOWN) && (!(oldpad.Buttons & DOWN))) {
				if (curMenuLevel < config.level+1) curMenuLevel++;
				else curMenuLevel = 0;
				playSound(CLICK_PATH);
			}

			// Cross routine
			if ((pad.Buttons & CROSS) && (!(oldpad.Buttons & CROSS))) {
				playSound(CLICK_PATH);
				break;
			}
		}

		// Control any sounds
		if (MP3_EndOfStream())
			MP3_Stop();

		// Flip
		flip();
	}

	// Quick bug fix?
	fillScreenRect(RGB(0, 0, 0), 0, 0, 480, 272);
	flip();

	return curMenuLevel;
}


