/*
/////////////////////////////////////////////////////////////////
////////////////////		PSP Bound		/////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////    July 23, 2006   ////////////////////////
///////////////////// Created by Slasher ////////////////////////
/////////////////////////////////////////////////////////////////
*/

///// Includes /////
/* Includes */
#include <pspkernel.h>
#include <pspdebug.h>
#include <pspdisplay.h>
#include <pspctrl.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <pspaudiolib.h>
#include <pspsdk.h>
#include <time.h>

/* GFX Includes */
#include "graphics.h"
#include "fontloader.h"

/* SFX Include */
#include "mp3player.h"

/* Regular Includes */
#include "common.c"
#include "callbacks.c"
#include "display.h"
#include "input.h"
#include "leveldata.h"
#include "conf.h"


///// Module Info /////
PSP_MODULE_INFO("PSP Bound", 0, 1, 1);	// User
PSP_MAIN_THREAD_ATTR(0);


///// Main - Entry Point /////
int main()
{
	/* Init */
	pspDebugScreenInit();
	SetupCallbacks();
	pspAudioInit();
	MP3_Init(0);
	initGraphics();
	initImages();
	initVars();

	// These variable are IMPORTANT
	// Must be set once, and once only
	curMenuLevelPick = 0;
	curMenuLevel = 0;
	sens = 42;

	
	sceDisplayWaitVblankStart();

	// Main loop
	for (;;) {
		// Current state
		switch (state) {
			// The menu
			case STATE_MENU:

				draw(STATE_MENU);
				input(STATE_MENU);

				// Control any sounds
				if (MP3_EndOfStream())
					MP3_Stop();

				break;
			// The game
			case STATE_GAME:

				draw(STATE_GAME);
				input(STATE_GAME);

				// Control any sounds
				if (MP3_EndOfStream())
					MP3_Stop();

				break;
			// The options
			case STATE_OPTIONS:

				draw(STATE_OPTIONS);
				input(STATE_OPTIONS);

				// Control any sounds
				if (MP3_EndOfStream())
					MP3_Stop();

				break;
			// Exit
			case STATE_EXIT:

				goto exit;

				break;
			//
		}
		
		// Flip
		flip();
	}

// Exit (incase of 2.0+ & no callbacks)
exit:
	// Todo - unload EVERYTHING
	Font_Unload(myFont);
	MP3_End();
	pspAudioEnd();
	
	sceKernelExitGame();
	return 0;
}
